
/*
 * This file was generated by the SOM Compiler.
 * FileName: ..\..\pentkt\h\idrreco.h.
 * Generated using:
 *     SOM Precompiler somipc: 2.7
 *     SOM Emitter emith: 2.22
 */

/*
 * 
 *    CLASS: IDRReco
 * 
 *    CLASS HIERARCHY:
 * 
 *      SOMObject
 *         IDRReco
 * 
 *    DESCRIPTION:
 * 
 *      Generic input data recognition class.
 */


#ifndef SOM_IDRReco_h
#define SOM_IDRReco_h


/*
 * Passthru lines: File: "C.h", "before"
 */



#pragma pack(2)

/*
** Input Data Recognition (IDR) error codes.
** Certain OS/2 error codes are also used directly. (for ex. NO_ERROR)
*/
#include "idrerror.h"

/*
**  Defines for symbol types.
*/

#define IDR_TYPE_ASCII          (USHORT)(0x0002)
#define IDR_TYPE_CTRL           (USHORT)(0xffff)
#define IDR_TYPE_SYSGESTURE     (USHORT)(0x8001)
#define IDR_TYPE_LETTERGESTURE  (USHORT)(0x8002)


typedef struct _IDR_SYM         /* Basic symbol */
{
  USHORT    usSymType;          /* Symbol, e.g. ASCII, etc. */
  USHORT    usSymVal;           /* Symbol value, For IDR_TYPE_ASCII and 
                                   IDR_TYPE_LETTERGESTURE, this is the
                                   "code point" on the current code page.
                                   For IDR_TYPE_SYSGESTURE this is the
                                   gesture's virtual id. */ 
}   IDR_SYM,
   *PIDR_SYM,
  **PPIDR_SYM;

/*
**  Defines for text and gesture symbol subsets.
*/

#define IDR_SYMSET_FULL        (0x10000000)    /* full symbol set; this is the default */

/*
**  Defines for text symbol subsets. These are valid in text mode only.
*/

#define IDR_SYMSET_ALPHALO     (0x00000001)   /* lower-alphabetic text symbols */
#define IDR_SYMSET_ALPHAHI     (0x00000002)   /* upper-alphabetic text symbols */
#define IDR_SYMSET_DIGIT       (0x00000004)   /* digits; 0 through 9 */
#define IDR_SYMSET_MONETARY    (0x00000008)   /* monetary symbols */
#define IDR_SYMSET_MATH        (0x00000010)   /* mathematical symbols */
#define IDR_SYMSET_PUNCTUATION (0x00000020)   /* punctuation symbols */
#define IDR_SYMSET_SPECIAL     (0x00000040)   /* special symbols */


typedef struct _IDR_SYMSET /* Symbol set */
{
  ULONG ulSymSets;              /* Symbol subset mask */
  ULONG ulSymCnt;               /* Count of symbols in the symbol list. */
  IDR_SYM SymList[1];           /* Contiguous array of symbols. */
}  IDR_SYMSET,
  *PIDR_SYMSET,
 **PPIDR_SYMSET;


/*
**  Defines used for setting the metrics.
**  Space disabling is only used if all strokes are known to belong to one word.
**  Direction is defaulted by the object.
*/

#define IDR_INKFORM_SINGLE_SYM      (0x00000002)
#define IDR_INKFORM_BOXED           (0x00000004)
#define IDR_INKFORM_LINED           (0x00000008)
#define IDR_INKFORM_UNLINED         (0x00000010)

#define IDR_INKSPACE_DISABLE_OFF    (0x00000000)
#define IDR_INKSPACE_DISABLE_ON     (0x00000001)

#define IDR_INKDIRECT_RIGHT_DOWN    (0x00000001) /* Left->right, top->bottom */ 


typedef struct _IDR_INKMETRICS
{
  ULONG           ulSSize;          /* IDR_INKMETRICS size                 */
  ULONG           ulRecoForm;       /* Type of segmentation                */
  ULONG           ulSpaceDisable;   /* Don't return any whitespace         */
  ULONG           ulDirection;      /* Direction of "normal" writing     */
  POINTL          ptlOrigin;        /* Origin                              */
  POINTL          ptlOffset;        /* Offset of "gray" area from Origin */
  POINTL          ptlBox;           /* Box extents (width & height)        */
  POINTL          ptlGray;          /* "Gray" area between boxes         */
  LONG            lOffsetBline;     /* Baseline offset from bottom of Box  */
  ULONG           ulRowCount;       /* Row count, 0 == indeterminate       */
  ULONG           ulColCount;       /* Column count, 0 == indeterminate    */
}  IDR_INKMETRICS,
  *PIDR_INKMETRICS,
 **PPIDR_INKMETRICS;

#pragma pack()



#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef IDRReco
#define IDRReco SOMObject
#endif
#include <somobj.h>

/*
 * Start of user-defined types:
 */
#ifndef SOMClass
    #define SOMClass SOMObject
#endif /* SOMClass */
#ifndef SOMObject
    #define SOMObject SOMObject
#endif /* SOMObject */
#ifndef M_IDRReco
    #define M_IDRReco SOMObject
#endif /* M_IDRReco */
#ifndef IDOStroke
    #define IDOStroke SOMObject
#endif /* IDOStroke */
#define ex_IDRReco_IDR_PROB "::IDRReco::IDR_PROB"
typedef
struct IDRReco_IDR_PROB {
ULONG ulErrorCode;
} IDRReco_IDR_PROB;

#ifndef SOM_DONT_USE_SHORT_NAMES
#ifndef SOMTGD_ex_IDR_PROB
    #ifdef ex_IDR_PROB
        #undef ex_IDR_PROB
        #define SOMTGD_ex_IDR_PROB 1
    #else
        #define ex_IDR_PROB ex_IDRReco_IDR_PROB
    #endif /* ex_IDR_PROB */
#endif /* SOMTGD_ex_IDR_PROB */
#ifndef SOMTGD_IDR_PROB
    #ifdef IDR_PROB
        #undef IDR_PROB
        #define SOMTGD_IDR_PROB 1
    #else
        #define IDR_PROB IDRReco_IDR_PROB
    #endif /* IDR_PROB */
#endif /* SOMTGD_IDR_PROB */
#endif /* SOM_DONT_USE_SHORT_NAMES */

/*
 * End of user-defined types.
 */

/*
 * Passthru lines: File: "C.h", "after"
 */



#define IDRReco_MajorVersion 0
#define IDRReco_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define IDRRecoNewClass c
#pragma linkage(c, system)
#define IDRRecoClassData d
#define IDRRecoCClassData x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */

/*
 * Include the meta class file
 */
#include <idrreco.h>
/*--------------Migration------------*/
#define IDRReco_classObj IDRRecoClassData.classObject
#define _IDRReco IDRReco_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK IDRRecoNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(IDRRecoNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct IDRRecoClassDataStructure {
	SOMAny *classObject;
	somMToken idrSetSymSet;
	somMToken idrGetSymSet;
	somMToken idrSetSymbolSubset;
	somMToken idrGetSymbolSubset;
	somMToken idrGetSymbolSubsetInfo;
	somMToken idrSetMetrics;
	somMToken idrGetMetrics;
	somMToken idrAddStroke;
	somMToken idrAddStrokefromStrokeObject;
	somMToken idrClearStrokes;
	somMToken idrSetEngEntryPts;
	somMToken idrSetInstHdls;
	somMToken idrSetCfgValues;
	somMToken idrSetDefaults;
	somMToken idrResetToDefaults;
	somMToken idrSetSymSubsets;
	somMToken idrSetLngMdlUsage;
	somMToken idrSetTrainData;
	somMToken idrGetDefaults;
	somMToken idrGetInstHdls;
	somMToken idrGetEngEntryPts;
	somMToken idrGetCfgValues;
	somMToken idrGetSymSubsets;
	somMToken idrGetLngMdlUsage;
	somMToken idrGetCompCfgCaps;
	somMToken idrGetDataCfgCaps;
	somMToken idrGetTrainData;
	somMToken idrAddRawData;
	somMToken idrDelData;
	somMToken idrDelRawData;
	somMToken idrDataComplete;
	somMToken idrDataClear;
	somMToken idrGetGrf;
	somMToken idrCopyGrf;
	somMToken idrGetGrfChildAltCnt;
	somMToken idrGetGrfChildHndls;
	somMToken idrGetGrfInfoAltCnt;
	somMToken idrGetGrfInfo;
	somMToken idrSetXlateInfo;
	somMToken idrGetXlateInfo;
	somMToken idrXlateSym;
	somMToken idrSetMetricsDefaults;
	somMToken idrGetMetricsDefaults;
	somMToken idrSetState;
	somMToken idrGetState;
	somMToken idrSaveCfg;
	somMToken idrRestoreCfg;
	somMToken idrGetDescriptionFromFile;
	somMToken idrCopyEnviron;
	somMToken idrIGetTrainStatus;
} IDRRecoClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct IDRRecoCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} IDRRecoCClassData;

/*
 * New and Renew macros for IDRReco
 */
#define IDRRecoNew() \
	( IDRRecoClassData.classObject \
		? (_somNew(IDRRecoClassData.classObject)) \
		: ( IDRRecoNewClass(IDRReco_MajorVersion, IDRReco_MinorVersion), (_somNew(IDRRecoClassData.classObject)) ) )
#define IDRRecoRenew(buf) \
	( _somRenew(IDRRecoClassData.classObject, buf) )

/*
 * Override method: somInit
 */
#define IDRReco_somInit(somSelf) \
	SOMObject_somInit(somSelf)

/*
 * Override method: somUninit
 */
#define IDRReco_somUninit(somSelf) \
	SOMObject_somUninit(somSelf)

/*
 * New Method: idrGetDescriptionFromFile
 */
typedef APIRET   SOMLINK somTP_IDRReco_idrGetDescriptionFromFile(IDRReco *somSelf, Environment *ev,
		PSZ pszFileName,
		PSZ pszDescription);
#pragma linkage(somTP_IDRReco_idrGetDescriptionFromFile, system)
typedef somTP_IDRReco_idrGetDescriptionFromFile *somTD_IDRReco_idrGetDescriptionFromFile;
#define somMD_IDRReco_idrGetDescriptionFromFile "::IDRReco::idrGetDescriptionFromFile"
#define IDRReco_idrGetDescriptionFromFile(somSelf,ev,pszFileName,pszDescription) \
    (SOM_Resolve(somSelf, IDRReco, idrGetDescriptionFromFile) \
	(somSelf,ev,pszFileName,pszDescription))
#ifndef SOMGD_idrGetDescriptionFromFile
    #if (defined(_idrGetDescriptionFromFile) || defined(__idrGetDescriptionFromFile))
        #undef _idrGetDescriptionFromFile
        #undef __idrGetDescriptionFromFile
        #define SOMGD_idrGetDescriptionFromFile 1
    #else
        #define _idrGetDescriptionFromFile IDRReco_idrGetDescriptionFromFile
    #endif /* _idrGetDescriptionFromFile */
#endif /* SOMGD_idrGetDescriptionFromFile */

/*
 * New Method: idrSetSymbolSubset
 */
typedef void   SOMLINK somTP_IDRReco_idrSetSymbolSubset(IDRReco *somSelf, Environment *ev,
		PIDR_SYMSET pSymSet);
#pragma linkage(somTP_IDRReco_idrSetSymbolSubset, system)
typedef somTP_IDRReco_idrSetSymbolSubset *somTD_IDRReco_idrSetSymbolSubset;
#define somMD_IDRReco_idrSetSymbolSubset "::IDRReco::idrSetSymbolSubset"
#define IDRReco_idrSetSymbolSubset(somSelf,ev,pSymSet) \
    (SOM_Resolve(somSelf, IDRReco, idrSetSymbolSubset) \
	(somSelf,ev,pSymSet))
#ifndef SOMGD_idrSetSymbolSubset
    #if (defined(_idrSetSymbolSubset) || defined(__idrSetSymbolSubset))
        #undef _idrSetSymbolSubset
        #undef __idrSetSymbolSubset
        #define SOMGD_idrSetSymbolSubset 1
    #else
        #define _idrSetSymbolSubset IDRReco_idrSetSymbolSubset
    #endif /* _idrSetSymbolSubset */
#endif /* SOMGD_idrSetSymbolSubset */

/*
 * New Method: idrGetSymbolSubset
 */
typedef void   SOMLINK somTP_IDRReco_idrGetSymbolSubset(IDRReco *somSelf, Environment *ev,
		PIDR_SYMSET pSymSet,
		PULONG pulSize);
#pragma linkage(somTP_IDRReco_idrGetSymbolSubset, system)
typedef somTP_IDRReco_idrGetSymbolSubset *somTD_IDRReco_idrGetSymbolSubset;
#define somMD_IDRReco_idrGetSymbolSubset "::IDRReco::idrGetSymbolSubset"
#define IDRReco_idrGetSymbolSubset(somSelf,ev,pSymSet,pulSize) \
    (SOM_Resolve(somSelf, IDRReco, idrGetSymbolSubset) \
	(somSelf,ev,pSymSet,pulSize))
#ifndef SOMGD_idrGetSymbolSubset
    #if (defined(_idrGetSymbolSubset) || defined(__idrGetSymbolSubset))
        #undef _idrGetSymbolSubset
        #undef __idrGetSymbolSubset
        #define SOMGD_idrGetSymbolSubset 1
    #else
        #define _idrGetSymbolSubset IDRReco_idrGetSymbolSubset
    #endif /* _idrGetSymbolSubset */
#endif /* SOMGD_idrGetSymbolSubset */

/*
 * New Method: idrGetSymbolSubsetInfo
 */
typedef void   SOMLINK somTP_IDRReco_idrGetSymbolSubsetInfo(IDRReco *somSelf, Environment *ev,
		ULONG ulSymSets,
		PULONG pulSymCnt,
		PIDR_SYM pSyms);
#pragma linkage(somTP_IDRReco_idrGetSymbolSubsetInfo, system)
typedef somTP_IDRReco_idrGetSymbolSubsetInfo *somTD_IDRReco_idrGetSymbolSubsetInfo;
#define somMD_IDRReco_idrGetSymbolSubsetInfo "::IDRReco::idrGetSymbolSubsetInfo"
#define IDRReco_idrGetSymbolSubsetInfo(somSelf,ev,ulSymSets,pulSymCnt,pSyms) \
    (SOM_Resolve(somSelf, IDRReco, idrGetSymbolSubsetInfo) \
	(somSelf,ev,ulSymSets,pulSymCnt,pSyms))
#ifndef SOMGD_idrGetSymbolSubsetInfo
    #if (defined(_idrGetSymbolSubsetInfo) || defined(__idrGetSymbolSubsetInfo))
        #undef _idrGetSymbolSubsetInfo
        #undef __idrGetSymbolSubsetInfo
        #define SOMGD_idrGetSymbolSubsetInfo 1
    #else
        #define _idrGetSymbolSubsetInfo IDRReco_idrGetSymbolSubsetInfo
    #endif /* _idrGetSymbolSubsetInfo */
#endif /* SOMGD_idrGetSymbolSubsetInfo */

/*
 * New Method: idrSetMetrics
 */
typedef void   SOMLINK somTP_IDRReco_idrSetMetrics(IDRReco *somSelf, Environment *ev,
		PIDR_INKMETRICS pMetrics);
#pragma linkage(somTP_IDRReco_idrSetMetrics, system)
typedef somTP_IDRReco_idrSetMetrics *somTD_IDRReco_idrSetMetrics;
#define somMD_IDRReco_idrSetMetrics "::IDRReco::idrSetMetrics"
#define IDRReco_idrSetMetrics(somSelf,ev,pMetrics) \
    (SOM_Resolve(somSelf, IDRReco, idrSetMetrics) \
	(somSelf,ev,pMetrics))
#ifndef SOMGD_idrSetMetrics
    #if (defined(_idrSetMetrics) || defined(__idrSetMetrics))
        #undef _idrSetMetrics
        #undef __idrSetMetrics
        #define SOMGD_idrSetMetrics 1
    #else
        #define _idrSetMetrics IDRReco_idrSetMetrics
    #endif /* _idrSetMetrics */
#endif /* SOMGD_idrSetMetrics */

/*
 * New Method: idrGetMetrics
 */
typedef void   SOMLINK somTP_IDRReco_idrGetMetrics(IDRReco *somSelf, Environment *ev,
		PIDR_INKMETRICS pMetrics);
#pragma linkage(somTP_IDRReco_idrGetMetrics, system)
typedef somTP_IDRReco_idrGetMetrics *somTD_IDRReco_idrGetMetrics;
#define somMD_IDRReco_idrGetMetrics "::IDRReco::idrGetMetrics"
#define IDRReco_idrGetMetrics(somSelf,ev,pMetrics) \
    (SOM_Resolve(somSelf, IDRReco, idrGetMetrics) \
	(somSelf,ev,pMetrics))
#ifndef SOMGD_idrGetMetrics
    #if (defined(_idrGetMetrics) || defined(__idrGetMetrics))
        #undef _idrGetMetrics
        #undef __idrGetMetrics
        #define SOMGD_idrGetMetrics 1
    #else
        #define _idrGetMetrics IDRReco_idrGetMetrics
    #endif /* _idrGetMetrics */
#endif /* SOMGD_idrGetMetrics */

/*
 * New Method: idrAddStroke
 */
typedef void   SOMLINK somTP_IDRReco_idrAddStroke(IDRReco *somSelf, Environment *ev,
		PSTROKEDATA pData,
		HWND hRelative);
#pragma linkage(somTP_IDRReco_idrAddStroke, system)
typedef somTP_IDRReco_idrAddStroke *somTD_IDRReco_idrAddStroke;
#define somMD_IDRReco_idrAddStroke "::IDRReco::idrAddStroke"
#define IDRReco_idrAddStroke(somSelf,ev,pData,hRelative) \
    (SOM_Resolve(somSelf, IDRReco, idrAddStroke) \
	(somSelf,ev,pData,hRelative))
#ifndef SOMGD_idrAddStroke
    #if (defined(_idrAddStroke) || defined(__idrAddStroke))
        #undef _idrAddStroke
        #undef __idrAddStroke
        #define SOMGD_idrAddStroke 1
    #else
        #define _idrAddStroke IDRReco_idrAddStroke
    #endif /* _idrAddStroke */
#endif /* SOMGD_idrAddStroke */

/*
 * New Method: idrAddStrokefromStrokeObject
 */
typedef void   SOMLINK somTP_IDRReco_idrAddStrokefromStrokeObject(IDRReco *somSelf, Environment *ev,
		IDOStroke* pStrokeObj);
#pragma linkage(somTP_IDRReco_idrAddStrokefromStrokeObject, system)
typedef somTP_IDRReco_idrAddStrokefromStrokeObject *somTD_IDRReco_idrAddStrokefromStrokeObject;
#define somMD_IDRReco_idrAddStrokefromStrokeObject "::IDRReco::idrAddStrokefromStrokeObject"
#define IDRReco_idrAddStrokefromStrokeObject(somSelf,ev,pStrokeObj) \
    (SOM_Resolve(somSelf, IDRReco, idrAddStrokefromStrokeObject) \
	(somSelf,ev,pStrokeObj))
#ifndef SOMGD_idrAddStrokefromStrokeObject
    #if (defined(_idrAddStrokefromStrokeObject) || defined(__idrAddStrokefromStrokeObject))
        #undef _idrAddStrokefromStrokeObject
        #undef __idrAddStrokefromStrokeObject
        #define SOMGD_idrAddStrokefromStrokeObject 1
    #else
        #define _idrAddStrokefromStrokeObject IDRReco_idrAddStrokefromStrokeObject
    #endif /* _idrAddStrokefromStrokeObject */
#endif /* SOMGD_idrAddStrokefromStrokeObject */

/*
 * New Method: idrClearStrokes
 */
typedef void   SOMLINK somTP_IDRReco_idrClearStrokes(IDRReco *somSelf, Environment *ev);
#pragma linkage(somTP_IDRReco_idrClearStrokes, system)
typedef somTP_IDRReco_idrClearStrokes *somTD_IDRReco_idrClearStrokes;
#define somMD_IDRReco_idrClearStrokes "::IDRReco::idrClearStrokes"
#define IDRReco_idrClearStrokes(somSelf,ev) \
    (SOM_Resolve(somSelf, IDRReco, idrClearStrokes) \
	(somSelf,ev))
#ifndef SOMGD_idrClearStrokes
    #if (defined(_idrClearStrokes) || defined(__idrClearStrokes))
        #undef _idrClearStrokes
        #undef __idrClearStrokes
        #define SOMGD_idrClearStrokes 1
    #else
        #define _idrClearStrokes IDRReco_idrClearStrokes
    #endif /* _idrClearStrokes */
#endif /* SOMGD_idrClearStrokes */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define IDRReco_somFree SOMObject_somFree
#define IDRReco_somDefaultInit SOMObject_somDefaultInit
#define IDRReco_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define IDRReco_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define IDRReco_somDestruct SOMObject_somDestruct
#define IDRReco_somDefaultAssign SOMObject_somDefaultAssign
#define IDRReco_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define IDRReco_somGetClass SOMObject_somGetClass
#define IDRReco_somGetClassName SOMObject_somGetClassName
#define IDRReco_somGetSize SOMObject_somGetSize
#define IDRReco_somIsA SOMObject_somIsA
#define IDRReco_somIsInstanceOf SOMObject_somIsInstanceOf
#define IDRReco_somRespondsTo SOMObject_somRespondsTo
#define IDRReco_somDispatchV SOMObject_somDispatchV
#define IDRReco_somDispatchL SOMObject_somDispatchL
#define IDRReco_somDispatchA SOMObject_somDispatchA
#define IDRReco_somDispatchD SOMObject_somDispatchD
#define IDRReco_somDispatch SOMObject_somDispatch
#define IDRReco_somClassDispatch SOMObject_somClassDispatch
#define IDRReco_somCastObj SOMObject_somCastObj
#define IDRReco_somResetObj SOMObject_somResetObj
#define IDRReco_somPrintSelf SOMObject_somPrintSelf
#define IDRReco_somDumpSelf SOMObject_somDumpSelf
#define IDRReco_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_IDRReco_h */

#ifndef SOM_M_IDRReco_h
#define SOM_M_IDRReco_h


#include <som.h>

/*
 * -- This emitter treats Method Tokens as Thunks by default
 * -- Use the sc modifier "nothunks" to change this default
 */
#undef somresolve_
#define somresolve_(obj,mToken) ((somMethodProc*)((void)obj, mToken))

/*
 * Define the class name as an object type
 */
#ifndef M_IDRReco
#define M_IDRReco SOMObject
#endif
#include <somcls.h>

/*
 * Start of user-defined types:
 */

/*
 * End of user-defined types.
 */

#define M_IDRReco_MajorVersion 0
#define M_IDRReco_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_IDRRecoNewClass c
#pragma linkage(c, system)
#define M_IDRRecoClassData d
#define M_IDRRecoCClassData x
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_IDRReco_classObj M_IDRRecoClassData.classObject
#define _M_IDRReco M_IDRReco_classObj

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMClass * SOMLINK M_IDRRecoNewClass(integer4 somtmajorVersion,
		integer4 somtminorVersion);
#pragma linkage(M_IDRRecoNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_IDRRecoClassDataStructure {
	SOMAny *classObject;
	somMToken idrclsGetEngineDescription;
	somMToken idrclsNewIDRReco;
	somMToken idrclsFreeIDR;
	somMToken idrclsSetCfgType;
	somMToken idrclsGetCfgType;
	somMToken idrclsSetCfgTypes;
	somMToken idrclsSetCfgDescs;
	somMToken idrclsSetCfg;
	somMToken idrclsAddCfgDesc;
	somMToken idrclsDelCfgDesc;
	somMToken idrclsAddCfg;
	somMToken idrclsReplaceCfg;
	somMToken idrclsDelCfg;
	somMToken idrclsSetDefaultCfg;
	somMToken idrclsGetCfgTypes;
	somMToken idrclsGetCfgDescs;
	somMToken idrclsGetCfg;
	somMToken idrclsNewCfgFromBase;
	somMToken idrclsNewDirFromBase;
	somMToken idrclsDelPath;
	somMToken idrclsGetDefaultCfg;
	somMToken idrclsGetCtlrHandle;
	somMToken idrclsEngCtlrResolve;
	somMToken idrclsCopyCfg;
	somMToken idrclsFreeCfg;
	somMToken idrclsCfgToInstance;
	somMToken idrclsCfgToInUse;
	somMToken idrclsCfgCompDataMatch;
	somMToken idrclsCfgCompMatch;
	somMToken idrclsCfgIniToCfg;
	somMToken idrclsCfgToCfgIni;
	somMToken idrclsInUseListAdd;
	somMToken idrclsInUseListRemove;
	somMToken idrclsInUseListLock;
	somMToken idrclsInUseListUnlock;
	somMToken idrclsInstListAdd;
	somMToken idrclsInstListRemove;
	somMToken idrclsInstListLock;
	somMToken idrclsInstListUnlock;
	somMToken idrclsGlobalLock;
	somMToken idrclsGlobalUnlock;
} M_IDRRecoClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_IDRRecoCClassDataStructure {
	somMethodTabs parentMtab;
	somDToken instanceDataToken;
} M_IDRRecoCClassData;

/*
 * New and Renew macros for M_IDRReco
 */
#define M_IDRRecoNew() \
	( M_IDRRecoClassData.classObject \
		? (_somNew(M_IDRRecoClassData.classObject)) \
		: ( M_IDRRecoNewClass(M_IDRReco_MajorVersion, M_IDRReco_MinorVersion), (_somNew(M_IDRRecoClassData.classObject)) ) )
#define M_IDRRecoRenew(buf) \
	( _somRenew(M_IDRRecoClassData.classObject, buf) )

/*
 * Override method: somInit
 */
#define M_IDRReco_somInit(somSelf) \
	SOMObject_somInit(somSelf)

/*
 * Override method: somUninit
 */
#define M_IDRReco_somUninit(somSelf) \
	SOMObject_somUninit(somSelf)

/*
 * New Method: idrclsGetEngineDescription
 */
typedef void   SOMLINK somTP_M_IDRReco_idrclsGetEngineDescription(M_IDRReco *somSelf, Environment *ev,
		PULONG pulSize,
		PSZ pszDescription);
#pragma linkage(somTP_M_IDRReco_idrclsGetEngineDescription, system)
typedef somTP_M_IDRReco_idrclsGetEngineDescription *somTD_M_IDRReco_idrclsGetEngineDescription;
#define somMD_M_IDRReco_idrclsGetEngineDescription "::M_IDRReco::idrclsGetEngineDescription"
#define M_IDRReco_idrclsGetEngineDescription(somSelf,ev,pulSize,pszDescription) \
    (SOM_Resolve(somSelf, M_IDRReco, idrclsGetEngineDescription) \
	(somSelf,ev,pulSize,pszDescription))
#ifndef SOMGD_idrclsGetEngineDescription
    #if (defined(_idrclsGetEngineDescription) || defined(__idrclsGetEngineDescription))
        #undef _idrclsGetEngineDescription
        #undef __idrclsGetEngineDescription
        #define SOMGD_idrclsGetEngineDescription 1
    #else
        #define _idrclsGetEngineDescription M_IDRReco_idrclsGetEngineDescription
    #endif /* _idrclsGetEngineDescription */
#endif /* SOMGD_idrclsGetEngineDescription */

/*
 * New Method: idrclsNewIDRReco
 */
typedef IDRReco*   SOMLINK somTP_M_IDRReco_idrclsNewIDRReco(M_IDRReco *somSelf, Environment *ev,
		PVOID pCfg);
#pragma linkage(somTP_M_IDRReco_idrclsNewIDRReco, system)
typedef somTP_M_IDRReco_idrclsNewIDRReco *somTD_M_IDRReco_idrclsNewIDRReco;
#define somMD_M_IDRReco_idrclsNewIDRReco "::M_IDRReco::idrclsNewIDRReco"
#define M_IDRReco_idrclsNewIDRReco(somSelf,ev,pCfg) \
    (SOM_Resolve(somSelf, M_IDRReco, idrclsNewIDRReco) \
	(somSelf,ev,pCfg))
#ifndef SOMGD_idrclsNewIDRReco
    #if (defined(_idrclsNewIDRReco) || defined(__idrclsNewIDRReco))
        #undef _idrclsNewIDRReco
        #undef __idrclsNewIDRReco
        #define SOMGD_idrclsNewIDRReco 1
    #else
        #define _idrclsNewIDRReco M_IDRReco_idrclsNewIDRReco
    #endif /* _idrclsNewIDRReco */
#endif /* SOMGD_idrclsNewIDRReco */

/*
 * New Method: idrclsFreeIDR
 */
typedef void   SOMLINK somTP_M_IDRReco_idrclsFreeIDR(M_IDRReco *somSelf, Environment *ev,
		IDRReco* pObject);
#pragma linkage(somTP_M_IDRReco_idrclsFreeIDR, system)
typedef somTP_M_IDRReco_idrclsFreeIDR *somTD_M_IDRReco_idrclsFreeIDR;
#define somMD_M_IDRReco_idrclsFreeIDR "::M_IDRReco::idrclsFreeIDR"
#define M_IDRReco_idrclsFreeIDR(somSelf,ev,pObject) \
    (SOM_Resolve(somSelf, M_IDRReco, idrclsFreeIDR) \
	(somSelf,ev,pObject))
#ifndef SOMGD_idrclsFreeIDR
    #if (defined(_idrclsFreeIDR) || defined(__idrclsFreeIDR))
        #undef _idrclsFreeIDR
        #undef __idrclsFreeIDR
        #define SOMGD_idrclsFreeIDR 1
    #else
        #define _idrclsFreeIDR M_IDRReco_idrclsFreeIDR
    #endif /* _idrclsFreeIDR */
#endif /* SOMGD_idrclsFreeIDR */
#ifndef SOM_DONT_USE_INHERITED_MACROS
#define M_IDRReco__get_somDirectInitClasses SOMClass__get_somDirectInitClasses
#define M_IDRReco__set_somDirectInitClasses SOMClass__set_somDirectInitClasses
#define M_IDRReco_somGetInstanceInitMask SOMClass_somGetInstanceInitMask
#define M_IDRReco_somGetInstanceDestructionMask SOMClass_somGetInstanceDestructionMask
#define M_IDRReco_somGetInstanceAssignmentMask SOMClass_somGetInstanceAssignmentMask
#define M_IDRReco_somGetInitMaskOffset SOMClass_somGetInitMaskOffset
#define M_IDRReco_somGetDestructionMaskOffset SOMClass_somGetDestructionMaskOffset
#define M_IDRReco_somAllocate SOMClass_somAllocate
#define M_IDRReco_somDeallocate SOMClass_somDeallocate
#define M_IDRReco_somNew SOMClass_somNew
#define M_IDRReco_somNewNoInit SOMClass_somNewNoInit
#define M_IDRReco_somRenew SOMClass_somRenew
#define M_IDRReco_somRenewNoInit SOMClass_somRenewNoInit
#define M_IDRReco_somRenewNoZero SOMClass_somRenewNoZero
#define M_IDRReco_somRenewNoInitNoZero SOMClass_somRenewNoInitNoZero
#define M_IDRReco_somInitClass SOMClass_somInitClass
#define M_IDRReco_somInitMIClass SOMClass_somInitMIClass
#define M_IDRReco_somAddStaticMethod SOMClass_somAddStaticMethod
#define M_IDRReco_somAddDynamicMethod SOMClass_somAddDynamicMethod
#define M_IDRReco_somClassReady SOMClass_somClassReady
#define M_IDRReco_somOverrideSMethod SOMClass_somOverrideSMethod
#define M_IDRReco_somGetApplyStub SOMClass_somGetApplyStub
#define M_IDRReco_somGetClassData SOMClass_somGetClassData
#define M_IDRReco_somSetClassData SOMClass_somSetClassData
#define M_IDRReco__get_somCClassData SOMClass__get_somCClassData
#define M_IDRReco__set_somCClassData SOMClass__set_somCClassData
#define M_IDRReco_somGetClassMtab SOMClass_somGetClassMtab
#define M_IDRReco_somGetInstanceOffset SOMClass_somGetInstanceOffset
#define M_IDRReco_somGetInstancePartSize SOMClass_somGetInstancePartSize
#define M_IDRReco_somGetInstanceSize SOMClass_somGetInstanceSize
#define M_IDRReco__get_somDataAlignment SOMClass__get_somDataAlignment
#define M_IDRReco_somGetInstanceToken SOMClass_somGetInstanceToken
#define M_IDRReco_somGetMemberToken SOMClass_somGetMemberToken
#define M_IDRReco_somGetMethodData SOMClass_somGetMethodData
#define M_IDRReco_somGetRdStub SOMClass_somGetRdStub
#define M_IDRReco_somGetMethodDescriptor SOMClass_somGetMethodDescriptor
#define M_IDRReco_somGetMethodIndex SOMClass_somGetMethodIndex
#define M_IDRReco_somGetMethodOffset SOMClass_somGetMethodOffset
#define M_IDRReco_somGetMethodToken SOMClass_somGetMethodToken
#define M_IDRReco_somGetName SOMClass_somGetName
#define M_IDRReco_somGetNthMethodData SOMClass_somGetNthMethodData
#define M_IDRReco_somGetNthMethodInfo SOMClass_somGetNthMethodInfo
#define M_IDRReco_somGetNumMethods SOMClass_somGetNumMethods
#define M_IDRReco_somGetNumStaticMethods SOMClass_somGetNumStaticMethods
#define M_IDRReco_somGetParent SOMClass_somGetParent
#define M_IDRReco_somGetParents SOMClass_somGetParents
#define M_IDRReco_somGetPClsMtab SOMClass_somGetPClsMtab
#define M_IDRReco_somGetPClsMtabs SOMClass_somGetPClsMtabs
#define M_IDRReco_somGetVersionNumbers SOMClass_somGetVersionNumbers
#define M_IDRReco_somSetMethodDescriptor SOMClass_somSetMethodDescriptor
#define M_IDRReco_somCheckVersion SOMClass_somCheckVersion
#define M_IDRReco_somDescendedFrom SOMClass_somDescendedFrom
#define M_IDRReco_somSupportsMethod SOMClass_somSupportsMethod
#define M_IDRReco_somGetClassDataEntry SOMClass_somGetClassDataEntry
#define M_IDRReco_somSetClassDataEntry SOMClass_somSetClassDataEntry
#define M_IDRReco_somDefinedMethod SOMClass_somDefinedMethod
#define M_IDRReco_somCastObjCls SOMClass_somCastObjCls
#define M_IDRReco_somResetObjCls SOMClass_somResetObjCls
#define M_IDRReco__get_somTrueClass SOMClass__get_somTrueClass
#define M_IDRReco__get_somCastedClass SOMClass__get_somCastedClass
#define M_IDRReco_somCloneClass SOMClass_somCloneClass
#define M_IDRReco_somFindMethod SOMClass_somFindMethod
#define M_IDRReco_somFindMethodOk SOMClass_somFindMethodOk
#define M_IDRReco_somFindSMethod SOMClass_somFindSMethod
#define M_IDRReco_somFindSMethodOk SOMClass_somFindSMethodOk
#define M_IDRReco_somLookupMethod SOMClass_somLookupMethod
#define M_IDRReco_somOverrideMtab SOMClass_somOverrideMtab
#define M_IDRReco__get_somInstanceDataOffsets SOMClass__get_somInstanceDataOffsets
#define M_IDRReco__get_somMethodOffsets SOMClass__get_somMethodOffsets
#define M_IDRReco_somDumpSelfInt SOMObject_somDumpSelfInt
#define M_IDRReco_somPrintSelf SOMObject_somPrintSelf
#define M_IDRReco_somFree SOMObject_somFree
#define M_IDRReco_somDefaultInit SOMObject_somDefaultInit
#define M_IDRReco_somDefaultCopyInit SOMObject_somDefaultCopyInit
#define M_IDRReco_somDefaultConstCopyInit SOMObject_somDefaultConstCopyInit
#define M_IDRReco_somDestruct SOMObject_somDestruct
#define M_IDRReco_somDefaultAssign SOMObject_somDefaultAssign
#define M_IDRReco_somDefaultConstAssign SOMObject_somDefaultConstAssign
#define M_IDRReco_somGetClass SOMObject_somGetClass
#define M_IDRReco_somGetClassName SOMObject_somGetClassName
#define M_IDRReco_somGetSize SOMObject_somGetSize
#define M_IDRReco_somIsA SOMObject_somIsA
#define M_IDRReco_somIsInstanceOf SOMObject_somIsInstanceOf
#define M_IDRReco_somRespondsTo SOMObject_somRespondsTo
#define M_IDRReco_somDispatchV SOMObject_somDispatchV
#define M_IDRReco_somDispatchL SOMObject_somDispatchL
#define M_IDRReco_somDispatchA SOMObject_somDispatchA
#define M_IDRReco_somDispatchD SOMObject_somDispatchD
#define M_IDRReco_somDispatch SOMObject_somDispatch
#define M_IDRReco_somClassDispatch SOMObject_somClassDispatch
#define M_IDRReco_somCastObj SOMObject_somCastObj
#define M_IDRReco_somResetObj SOMObject_somResetObj
#define M_IDRReco_somPrintSelf SOMObject_somPrintSelf
#define M_IDRReco_somDumpSelf SOMObject_somDumpSelf
#define M_IDRReco_somDumpSelfInt SOMObject_somDumpSelfInt
#endif /* SOM_DONT_USE_INHERITED_MACROS */

#endif       /* SOM_M_IDRReco_h */
